package com.fp.persistence.pgeneral.trans;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.*;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETRANSACTIONGLOSARY
 */
@Entity(name = "TgeneTransactionGlosary")
@Table(name = "TGENETRANSACTIONGLOSARY")
public class TgeneTransactionGlosary extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable {

    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;
    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;
    /**
     * Clave primaria de la Entidad TgeneTransactionGlosary
     */
    @EmbeddedId
    @GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SubSequenceKey", parameters = {
        @Parameter(name = "sql", value = "select coalesce(max(SEQUENCE),0)+1 from TGENETRANSACTIONGLOSARY "
        + "where TRANSACTIONMODULE=:transactionmodule "
        + "and TRANSACTIONCODE=:transactioncode "
        + "and TRANSACTIONVERSION=:transactionversion "
        + "and LANGUAGECODE = :languagecode"),
        @Parameter(name = "type", value = "java.lang.Long"),
        @Parameter(name = "param", value = "transactionmodule,pk.transactionmodule;transactioncode,pk.transactioncode;transactionversion,pk.transactionversion;languagecode,pk.languagecode"),
        @Parameter(name = "field", value = "sequence")})
    @GeneratedValue(generator = "seq_id")
    private TgeneTransactionGlosaryKey pk;
    @Version
    @Column(name = "RECORDVERSION", nullable = false)
    /**
     * Optimistic locking del registro
     */
    private Integer recordversion;
    @Column(name = "DESCRIPTIONSHORT", nullable = false)
    /**
     * Descripcion de glosario
     */
    private String descriptionshort;
    @Column(name = "DESCRIPTION", nullable = false)
    /**
     * Descripcion del glosario
     */
    private String description;

    /**
     * Contructor por defecto
     */
    public TgeneTransactionGlosary() {
    }

    /**
     * Contructor de TgeneTransactionGlosary
     *
     * @param pPk Clave Primaria del entity
     * @param pRecordversion Optimistic locking del registro
     * @param pDescriptionshort Descripcion de glosario
     * @param pDescription Descripcion del glosario
     */
    public TgeneTransactionGlosary(TgeneTransactionGlosaryKey pPk, Integer pRecordversion, String pDescriptionshort, String pDescription) {
        this();
        pk = pPk;
        recordversion = pRecordversion;
        descriptionshort = pDescriptionshort;
        description = pDescription;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     *
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TgeneTransactionGlosary
     */
    public static TgeneTransactionGlosary find(EntityManager pEntityManager, TgeneTransactionGlosaryKey pKey) throws Exception {
        TgeneTransactionGlosary obj = pEntityManager.find(TgeneTransactionGlosary.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TgeneTransactionGlosary
     *
     * @return El objeto que referencia a la Clave primaria de
     * TgeneTransactionGlosary
     */
    public TgeneTransactionGlosaryKey getPk() {
        return pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TgeneTransactionGlosary
     *
     * @param pPk El objeto que referencia a la nueva Clave primaria de
     * TgeneTransactionGlosary
     */
    public void setPk(TgeneTransactionGlosaryKey pPk) {
        pk = pPk;
    }

    /**
     * Obtiene el valor de recordversion
     *
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return recordversion;
    }

    /**
     * Fija el valor de recordversion
     *
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        recordversion = pRecordversion;
    }

    /**
     * Obtiene el valor de descriptionshort
     *
     * @return valor de descriptionshort
     */
    public String getDescriptionshort() {
        return descriptionshort;
    }

    /**
     * Fija el valor de descriptionshort
     *
     * @param pDescriptionshort nuevo Valor de descriptionshort
     */
    public void setDescriptionshort(String pDescriptionshort) {
        descriptionshort = pDescriptionshort;
    }

    /**
     * Obtiene el valor de description
     *
     * @return valor de description
     */
    public String getDescription() {
        return description;
    }

    /**
     * Fija el valor de description
     *
     * @param pDescription nuevo Valor de description
     */
    public void setDescription(String pDescription) {
        description = pDescription;
    }

    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TgeneTransactionGlosary)) {
            return false;
        }
        TgeneTransactionGlosary that = (TgeneTransactionGlosary) rhs;
        if (this.getPk() == null || that.getPk() == null) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementacion del metodo hashCode de la la entidad
     * TgeneTransactionGlosary
     *
     * @return el hashCode la instancia
     */
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /**
     * Implementacion toString
     */
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /**
     * Implementacion de la creacion de un bean en blanco
     * TgeneTransactionGlosary
     */
    public Object createInstance() {
        TgeneTransactionGlosary instance = new TgeneTransactionGlosary();
        instance.setPk(new TgeneTransactionGlosaryKey());
        return instance;
    }

    /**
     * Clona la entidad TgeneTransactionGlosary
     *
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    public Object cloneMe() throws CloneNotSupportedException {
        TgeneTransactionGlosary p = (TgeneTransactionGlosary) this.clone();
        p.setPk((TgeneTransactionGlosaryKey) this.pk.cloneMe());
        return p;
    }
}
